#include <ADuC7026.h>
#include <I2C_Master.h>

unsigned char Steps, Status;
extern unsigned char ReadData[8], WriteData[8];

void I2C_WRITE_REGISTER(unsigned char DeviceAddr, unsigned char RegisterStartAddr, unsigned char NumberOfBytes)
{
	Status=0;
	Steps=NumberOfBytes+1;
	I2C1ADR = DeviceAddr<<1;
	I2C1CNT=NumberOfBytes-1;
	I2C1MTX = RegisterStartAddr;

	while(Steps != Status)
	{
	    ;
	}
		
}

void I2C_READ_REGISTER(unsigned char DeviceAddr, unsigned char RegisterStartAddr, unsigned char NumberOfBytes)
{
	Status=0;
	Steps=1;
	I2C1ADR = DeviceAddr<<1;
	I2C1MTX = RegisterStartAddr;

	while(Steps != Status)
	{
	    ;
	}

	Status=0;
	Steps=NumberOfBytes;
	I2C1CNT=NumberOfBytes-1;
	I2C1ADR = (DeviceAddr<<1)+1;
	while(Steps != Status)
	{
	    ;
	}

}

 void FIQ_Handler() __fiq      //I2Cж
{

	// Transmit  
	if(((I2C1MSTA & 0x4) == 0x4) && (Status < (Steps-1)) )	
	{
		I2C1MTX = WriteData[Status];
		Status++;
	}		
	else if(((I2C1MSTA & 0x4) == 0x4) && (Status == (Steps-1)))
	{						  
	    Status ++;
	}	


    //Receive    
	else if (((I2C1MSTA & 0x8) == 0x8) && (Status <= (Steps-1)))
	{	   
       	ReadData[Status] =  I2C1MRX;
        Status ++;		  
	}  
    
}   
